<html>
<head>
<title>OgreConvexBody.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreConvexBody.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreConvexBody_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Copyright (c) 2006 Matthias Fink, netAllied GmbH &lt;matthias.fink@web.de&gt;                             </span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00011"></a>00011 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00012"></a>00012 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00013"></a>00013 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00014"></a>00014 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00015"></a>00015 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00016"></a>00016 <span class="comment"></span>
<a name="l00017"></a>00017 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00018"></a>00018 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00019"></a>00019 <span class="comment"></span>
<a name="l00020"></a>00020 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00021"></a>00021 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00022"></a>00022 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00023"></a>00023 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00024"></a>00024 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00025"></a>00025 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00026"></a>00026 <span class="comment">THE SOFTWARE.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __ConvexBody_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __ConvexBody_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgrePolygon_8h.html">OgrePolygon.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00051"></a><a class="code" href="classOgre_1_1ConvexBody.html">00051</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ConvexBody.html" title="Holds a solid representation of a convex body.">ConvexBody</a>
<a name="l00052"></a>00052     {
<a name="l00053"></a>00053     <span class="keyword">public</span>:
<a name="l00054"></a><a class="code" href="classOgre_1_1ConvexBody.html#a7064b26a96cd25b8aeb5ba40640ef7b8">00054</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt; Polygon* &gt;::type</a>    <a class="code" href="classOgre_1_1ConvexBody.html#a7064b26a96cd25b8aeb5ba40640ef7b8">PolygonList</a>;
<a name="l00055"></a>00055 
<a name="l00056"></a>00056     <span class="keyword">protected</span>:
<a name="l00057"></a><a class="code" href="classOgre_1_1ConvexBody.html#a4a9287e8e6a68839a451150959b1cd95">00057</a>         <a class="code" href="classOgre_1_1ConvexBody.html#a7064b26a96cd25b8aeb5ba40640ef7b8">PolygonList</a> <a class="code" href="classOgre_1_1ConvexBody.html#a4a9287e8e6a68839a451150959b1cd95">mPolygons</a>;
<a name="l00058"></a>00058 
<a name="l00059"></a>00059         <span class="comment">// Static &#39;free list&#39; of polygons to save reallocation, shared between all bodies</span>
<a name="l00060"></a><a class="code" href="classOgre_1_1ConvexBody.html#a8f45e2762a61cfa1ce2cf11fbc8cb6a9">00060</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1ConvexBody.html#a7064b26a96cd25b8aeb5ba40640ef7b8">PolygonList</a> <a class="code" href="classOgre_1_1ConvexBody.html#a8f45e2762a61cfa1ce2cf11fbc8cb6a9">msFreePolygons</a>;
<a name="l00061"></a>00061 <span class="preprocessor">#if OGRE_THREAD_SUPPORT</span>
<a name="l00062"></a>00062 <span class="preprocessor"></span>        <a class="code" href="OgrePrerequisites_8h.html#ac853de57688aefaec88f75cd9e0ac388">OGRE_STATIC_MUTEX</a>(msFreePolygonsMutex)
<a name="l00063"></a>00063 <span class="preprocessor">#endif</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span>
<a name="l00065"></a>00065     <span class="keyword">public</span>:
<a name="l00066"></a>00066         <a class="code" href="classOgre_1_1ConvexBody.html" title="Holds a solid representation of a convex body.">ConvexBody</a>();
<a name="l00067"></a>00067         ~<a class="code" href="classOgre_1_1ConvexBody.html" title="Holds a solid representation of a convex body.">ConvexBody</a>();
<a name="l00068"></a>00068         <a class="code" href="classOgre_1_1ConvexBody.html" title="Holds a solid representation of a convex body.">ConvexBody</a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1ConvexBody.html" title="Holds a solid representation of a convex body.">ConvexBody</a>&amp; cpy );
<a name="l00069"></a>00069 
<a name="l00072"></a>00072         <span class="keywordtype">void</span> define(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Frustum.html" title="A frustum represents a pyramid, capped at the near and far end which is used to represent either a vi...">Frustum</a>&amp; frustum);
<a name="l00073"></a>00073 
<a name="l00076"></a>00076         <span class="keywordtype">void</span> define(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; aab);
<a name="l00077"></a>00077 
<a name="l00081"></a>00081         <span class="keywordtype">void</span> clip( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Frustum.html" title="A frustum represents a pyramid, capped at the near and far end which is used to represent either a vi...">Frustum</a>&amp; frustum );
<a name="l00082"></a>00082 
<a name="l00086"></a>00086         <span class="keywordtype">void</span> clip( <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; aab );
<a name="l00087"></a>00087 
<a name="l00090"></a>00090         <span class="keywordtype">void</span> clip(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ConvexBody.html" title="Holds a solid representation of a convex body.">ConvexBody</a>&amp; body);
<a name="l00091"></a>00091 
<a name="l00094"></a>00094         <span class="keywordtype">void</span> clip(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; pl, <span class="keywordtype">bool</span> keepNegative = <span class="keyword">true</span>);
<a name="l00095"></a>00095 
<a name="l00102"></a>00102         <span class="keywordtype">void</span> extend(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; pt);
<a name="l00103"></a>00103 
<a name="l00106"></a>00106         <span class="keywordtype">void</span> reset( <span class="keywordtype">void</span> );
<a name="l00107"></a>00107 
<a name="l00110"></a>00110         <span class="keywordtype">size_t</span> getPolygonCount( <span class="keywordtype">void</span> ) <span class="keyword">const</span>;
<a name="l00111"></a>00111 
<a name="l00114"></a>00114         <span class="keywordtype">size_t</span> getVertexCount( <span class="keywordtype">size_t</span> poly ) <span class="keyword">const</span>;
<a name="l00115"></a>00115 
<a name="l00118"></a>00118         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Polygon.html" title="The class represents a polygon in 3D space.">Polygon</a>&amp; getPolygon( <span class="keywordtype">size_t</span> poly ) <span class="keyword">const</span>;
<a name="l00119"></a>00119 
<a name="l00122"></a>00122         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getVertex( <span class="keywordtype">size_t</span> poly, <span class="keywordtype">size_t</span> vertex ) <span class="keyword">const</span>;
<a name="l00123"></a>00123 
<a name="l00126"></a>00126         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getNormal( <span class="keywordtype">size_t</span> poly );
<a name="l00127"></a>00127 
<a name="l00130"></a>00130         <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> getAABB( <span class="keywordtype">void</span> ) <span class="keyword">const</span>;
<a name="l00131"></a>00131 
<a name="l00134"></a>00134         <span class="keywordtype">bool</span> hasClosedHull( <span class="keywordtype">void</span> ) <span class="keyword">const</span>;
<a name="l00135"></a>00135 
<a name="l00139"></a>00139         <span class="keywordtype">void</span> mergePolygons( <span class="keywordtype">void</span> );
<a name="l00140"></a>00140 
<a name="l00143"></a>00143         <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator == </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1ConvexBody.html" title="Holds a solid representation of a convex body.">ConvexBody</a>&amp; rhs ) <span class="keyword">const</span>;
<a name="l00144"></a>00144 
<a name="l00147"></a><a class="code" href="classOgre_1_1ConvexBody.html#a54167fd6c91338d1d107fa866c329a3b">00147</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator != </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1ConvexBody.html" title="Holds a solid representation of a convex body.">ConvexBody</a>&amp; rhs )<span class="keyword"> const</span>
<a name="l00148"></a>00148 <span class="keyword">        </span>{ <span class="keywordflow">return</span> !( *<span class="keyword">this</span> == rhs ); }
<a name="l00149"></a>00149 
<a name="l00152"></a>00152         <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> std::ostream&amp; <a class="code" href="group__General.html#ga6d67d46d838de3b38264f17fb792cddc">operator&lt;&lt; </a>( std::ostream&amp; strm, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ConvexBody.html" title="Holds a solid representation of a convex body.">ConvexBody</a>&amp; body );
<a name="l00153"></a>00153 
<a name="l00155"></a>00155         <span class="keywordtype">void</span> logInfo() <span class="keyword">const</span>;
<a name="l00156"></a>00156 
<a name="l00158"></a>00158         <span class="keyword">static</span> <span class="keywordtype">void</span> _initialisePool();
<a name="l00160"></a>00160         <span class="keyword">static</span> <span class="keywordtype">void</span> _destroyPool();
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a>00163     <span class="keyword">protected</span>:
<a name="l00166"></a>00166         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Polygon.html" title="The class represents a polygon in 3D space.">Polygon</a>* allocatePolygon();
<a name="l00168"></a>00168         <span class="keyword">static</span> <span class="keywordtype">void</span> freePolygon(<a class="code" href="classOgre_1_1Polygon.html" title="The class represents a polygon in 3D space.">Polygon</a>* poly);
<a name="l00174"></a>00174         <span class="keywordtype">void</span> insertPolygon(<a class="code" href="classOgre_1_1Polygon.html" title="The class represents a polygon in 3D space.">Polygon</a>* pdata, <span class="keywordtype">size_t</span> poly);
<a name="l00180"></a>00180         <span class="keywordtype">void</span> insertPolygon(<a class="code" href="classOgre_1_1Polygon.html" title="The class represents a polygon in 3D space.">Polygon</a>* pdata);
<a name="l00181"></a>00181 
<a name="l00187"></a>00187         <span class="keywordtype">void</span> insertVertex(<span class="keywordtype">size_t</span> poly, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vdata, <span class="keywordtype">size_t</span> vertex);
<a name="l00193"></a>00193         <span class="keywordtype">void</span> insertVertex(<span class="keywordtype">size_t</span> poly, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vdata);
<a name="l00196"></a>00196         <span class="keywordtype">void</span> deletePolygon(<span class="keywordtype">size_t</span> poly);
<a name="l00197"></a>00197 
<a name="l00202"></a>00202         <a class="code" href="classOgre_1_1Polygon.html" title="The class represents a polygon in 3D space.">Polygon</a>* unlinkPolygon(<span class="keywordtype">size_t</span> poly);
<a name="l00203"></a>00203 
<a name="l00207"></a>00207         <span class="keywordtype">void</span> moveDataFromBody(<a class="code" href="classOgre_1_1ConvexBody.html" title="Holds a solid representation of a convex body.">ConvexBody</a>&amp; body);
<a name="l00208"></a>00208 
<a name="l00211"></a>00211         <span class="keywordtype">void</span> deleteVertex(<span class="keywordtype">size_t</span> poly, <span class="keywordtype">size_t</span> vertex);
<a name="l00212"></a>00212 
<a name="l00217"></a>00217         <span class="keywordtype">void</span> setPolygon(<a class="code" href="classOgre_1_1Polygon.html" title="The class represents a polygon in 3D space.">Polygon</a>* pdata, <span class="keywordtype">size_t</span> poly );
<a name="l00218"></a>00218 
<a name="l00224"></a>00224         <span class="keywordtype">void</span> setVertex( <span class="keywordtype">size_t</span> poly, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vdata, <span class="keywordtype">size_t</span> vertex );
<a name="l00225"></a>00225 
<a name="l00229"></a>00229         <a class="code" href="classOgre_1_1Polygon.html#a41cea1c56ef6ae8aec9e15b63a0cd4a6">Polygon::EdgeMap</a> getSingleEdges() <span class="keyword">const</span>;
<a name="l00230"></a>00230 
<a name="l00233"></a>00233         <span class="keywordtype">void</span> storeEdgesOfPolygon(<span class="keywordtype">size_t</span> poly, <a class="code" href="classOgre_1_1Polygon.html#a41cea1c56ef6ae8aec9e15b63a0cd4a6">Polygon::EdgeMap</a> *edgeMap) <span class="keyword">const</span>;
<a name="l00234"></a>00234             
<a name="l00240"></a>00240         <span class="keywordtype">void</span> allocateSpace(<span class="keywordtype">size_t</span> numPolygons, <span class="keywordtype">size_t</span> numVertices);
<a name="l00241"></a>00241 
<a name="l00250"></a>00250         <span class="keywordtype">bool</span> findAndEraseEdgePair(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec, 
<a name="l00251"></a>00251             <a class="code" href="classOgre_1_1Polygon.html#a41cea1c56ef6ae8aec9e15b63a0cd4a6">Polygon::EdgeMap</a>&amp; intersectionEdges, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vNext ) <span class="keyword">const</span>;
<a name="l00252"></a>00252 
<a name="l00253"></a>00253     };
<a name="l00257"></a>00257 }
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 <span class="preprocessor">#endif </span>
<a name="l00260"></a>00260 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
